;************************************************
;*                                              *
;*                  SCREEN plus                 *
;*                  Steffen Scharfe             *
;*                                              *
;*              (c) 1992 MAXON Computer         *
;*                 ST Computer 4/92             *
;************************************************

hblintr  equ $0120

v_bas_ad equ $044e
nvbls    equ $0454
vblqueue equ $0456
sysbase  equ $04f2

vcountlow equ $ffff8209 ; Video-Address counter, low-byte
shiftmode equ $ffff8260 ; ST shift mode

mfp  equ $fffffa01 ;MFP 68901
aer  equ $fffffa03 ;Aktive-Edge-Register
iera equ $fffffa07 ;Interrupt-Enable-Register A
isra equ $fffffa0f ;Interrupt-in-Service-Register A
imra equ $fffffa13 ;Interrupt-Mask-Register A
tbcr equ $fffffa1b ;Timer-B-Control-Register
tbdr equ $fffffa21 ;Timer-B-Data-Register

sync_mod equ $ffff820a ;Sync-Mode-Register


;(negative) Line-A-Variablen
DEV_TAB    equ -$2b4
V_CEL_MY   equ -$2a
V_REZ_VT   equ -4
CUR_FLAG   equ -$154
MOUSE_FLAG equ -$153
CUR_X      equ -$158
SAVE_LEN   equ -$14a
HIDE_CNT   equ -$256
M_POS_HX   equ -$358
v_planes   equ 0
v_lin_wr   equ 2

SV_LEN      equ 0
SV_ADDR		equ	2
SV_STAT		equ	6
SV_BUF		equ	8

SP_OFF		equ	0
SP_FG		equ	2
SP_BG		equ	4

RTN_REC	       	equ    	2*2
LF_OFF		equ	RTN_REC*1
RT_OFF		equ	RTN_REC*2

F_SAVRDY      equ     0       ; save buffer status: 0:empty  1:full
F_SAVWID      equ     1       ; saved line width:   0:word   1:longword

C_XHOT      equ 0
C_YHOT		equ	2
C_PLANES	equ	4
C_BGCOL		equ	6
C_FGCOL		equ	8
C_MSKFRM	equ	10

LINEA_BASE equ $299A

;Das hintere Programmstueck wird nur zur
;Initialisierung benoetigt

        bra init

;hier folgt nun das residente Programmstueck

;diese Trap #2-Routine wird nur einmal
;angesprungen, um nach der Initialisierung des
;VDI die Parameter der neuen Bildschirmhoehe zu
;setzen (245 Pixelzeilen)

;neuer Trap #2 Routine

trap_2:
        cmpi.w  #$73,d0             ;war dies ein VDI-Aufruf?
        bne.s   novdi               ;nein
        move.l  d1,a0
        movea.l (a0),a0             ;Zeiger auf Control-Array
        cmpi.w  #1,(a0)             ;Open Workstation?
        bne.s   novdi               ;nein
        lea     vdipb(pc),a0
        move.l  d1,(a0)             ;vdipb merken
        lea     return(pc),a0
        move.l  2(sp),(a0)          ;Return-Adresse merken
        lea     vdi(pc),a0
        move.l  a0,2(sp)            ;neue Return-Adresse
        movea.l vblqueue,a1
        lea     new_maus(pc),a0
        move.l  a0,(a1)             ;neue Mausroutine
novdi:
        movea.l old_vektor(pc),a1
        jmp     (a1)                ;ab zum Trap 2-Dispatcher



vdi:    movem.l d0-d2/a0-a2,-(sp)
        movea.l vdipb(pc),a0
        movea.l 12(a0),a1           ;Zeiger auf Intout-Array
        move.w  #244,2(a1)          ;neue Rasterhoehe
        movea.l linea_param(pc),a0
        move.w  #244,DEV_TAB+2(a0)  ;neue Werte in die negativen
        move.w  #30,V_CEL_MY(a0)    ;Line-A-Variablen eintragen
        move.w  #245,V_REZ_VT(a0)   ;45 Pixelzeilen mehr
		cmp.w   #1,v_planes(a0)
		bne.s   clear_screen
		move.w  #479,2(a1)
        move.w  #479,DEV_TAB+2(a0)  ;neue Werte in die negativen
        move.w  #30,V_CEL_MY(a0)    ;Line-A-Variablen eintragen
        move.w  #480,V_REZ_VT(a0)   ;80 Pixelzeilen mehr
clear_screen:
		move.l  screensize(pc),d0
		moveq   #0,d1
		lsr.l   #2,d0
		move.l  v_bas_ad,a0
clear_scr_loop:
		move.l  d1,(a0)+
		subq.l  #1,d0
		bne.s   clear_scr_loop

;        move.l  old_vektor(pc),-(sp)    ;ausklinken
;        move.w  #34,-(sp)
;        move.w  #5,-(sp)
;        trap    #13                 ;Setexc
;        addq.l  #8,sp

no_open:movem.l (sp)+,d0-d2/a0-a2
        movea.l return(pc),a1       ;alte Return-Adresse
        jmp     (a1)                ;zurueck ins Hauptprogramm

;leider notwendig ein neuer Maustreiber
; (wegen 1 Befehl !!)

new_maus:movea.l linea_param(pc),a5     ;wegen verschiedener BS-Varianten
        tst.w   HIDE_CNT(a5)        ;hidden counter (set by v_hide_c)
        bne.s   maus_end
        tst.b   MOUSE_FLAG(a5)      ;Maus-Flag (set during vsc_form)
        bne.s   maus_end
        bclr    #0,CUR_FLAG(a5)     ;Cur-Flag (set when mouse moves; marks CUR_X/Y valid)
        beq.s   maus_end
        move.l  CUR_X(a5),d1        ;x/y-Position
        move.l  d1,d0
        swap    d0
        movem.w d0-d1,-(sp)
        lea     SAVE_LEN(a5),a2     ;Save-Len
maus_adr1:
        bsr     cur_replace
        movem.w (sp)+,d0-d1
        movea.l linea_param(pc),a5
        lea     M_POS_HX(a5),a0     ;x-Hot-Spot
        lea     SAVE_LEN(a5),a2     ;Save-Len
        bsr.s   cur_display
maus_end:
        rts

cur_display:
        move.w  C_BGCOL(a0),-(sp)   ;Hintergrundfarbe 4(sp)
        move.w  C_FGCOL(a0),-(sp)   ;Vordergrundfarbe 2(sp)
        clr.w   d2
        tst.w   C_PLANES(a0)        ;Replace/Xor
        bge.s   replace             ;Replace-Modus
        moveq   #8,d2               ;XOR-Modus
replace:move.w  d2,-(sp)            ;Modus merken 0(sp)
        clr.w   d2
        bclr    #F_SAVWID,SV_STAT(a2) ;Words gebuffert
        sub.w   C_XHOT(a0),d0       ;x:=x-hotspot
        bcs.s   x_hotspot
        move.w  DEV_TAB(a5),d3      ;maximale Rasterbreite
        subi.w  #15,d3              ;minus 15
        cmp.w   d3,d0               ;Mauszeiger vollstaendig sichtbar?
        bhi.s   teilweise_x         ;nein
        bset    #F_SAVWID,SV_STAT(a2)  ;Longs gebuffert
        bra.s   maus_y

x_hotspot:
        addi.w  #16,d0
        moveq   #LF_OFF,d2          ;anmerken: x-hotspot
        bra.s   maus_y

teilweise_x:
        moveq   #RT_OFF,d2

maus_y: sub.w   C_YHOT(a0),d1       ;y:=y-hotspot
        lea     C_MSKFRM(a0),a0     ;Tabelle fuer Vordergrund und Maske
        bcs.s   y_hotspot
        move.w  DEV_TAB+2(a5),d3    ;Anzahl der Pixelzeilen
        subi.w  #15,d3
        cmp.w   d3,d1               ;Mauszeiger vollstaendig sichtbar?
        bhi.s   teilweise_y         ;nein
        moveq   #16,d5              ;ja -> Hoehe:=16 Pixelzeilen
        bra.s   maus1

y_hotspot:
        move.w  d1,d5
        addi.w  #16,d5              ;Hoehe berechnen
        asl.w   #2,d1               ;y:=y*4
        suba.w  d1,a0               ;ersten Pixelzeilen des Mauszeigers uebergehen
        clr.w   d1
        bra.s   maus1

teilweise_y:
        move.w  DEV_TAB+2(a5),d5    ;Anzahl der Pixelzeilen
        sub.w   d1,d5
        addq.w  #1,d5               ;Hoehe berechnen
maus1: 
        bsr     concat              ;rel Adresse im Bildspeicher
                                    ;ab der die Maus gezeichnet wird

        movea.l v_bas_ad,a1         ;Zeiger auf Anfang des Bildspeichers

;und nun der entscheidende Befehl
;aus adda.w d1,a1 wird...

        adda.l  d1,a1               ;absolute Adresse

;aha, die Maus funktioniert jetzt auch mit ueber
;32767 Bytes Bildspeicher

;weiter im Original-Programm
;
; init shift count
;
shift_lf:
        lea.l     r_lf_loop(pc),a3
        move.w    d0,d6
        cmp.w     #8,d6
        bcs.s     init2
        lea.l     r_rt_loop(pc),a3
        move.w    #16,d6
        sub.w     d0,d6
init2:
        move.w    v_planes(a5),d2
        move.w    v_lin_wr(a5),d4
        lea       rtn_tab(pc),a5
        move.l    a5,a6
        add.w     0(a5,d2.w),a5
        add.w     2(a6,d2.w),a6
        move.w    d2,d3
        add.w     d3,d3
        move.l    a1,SV_ADDR(a2)
        move.w    d5,SV_LEN(a2)
        bset      #F_SAVRDY,SV_STAT(a2)
        lea.l     SV_BUF(a2),a2
        move.l    a1,d7
        move.w    d5,d1
        bra.s     p_loop1

rtn_tab:
        dc.w      store_lw-rtn_tab,r_lw_entry-rtn_tab
        dc.w      store_rt-rtn_tab,r_rt_entry-rtn_tab
        dc.w      store_lf-rtn_tab,r_lf_entry-rtn_tab

p_loop:
        clr.w     d0
        lsr.w     SP_FG(a7)
        addx.w    d0,d0
        lsr.w     SP_BG(a7)
        addx.w    d0,d0
        add.w     d0,d0
        add.w     SP_OFF(a7),d0
        lea.l     op_tab(pc),a4
        add.w     0(a4,d0.w),a4
        movem.l   d1-d2,-(a7)
        jsr       (a6)
        movem.l   (a7)+,d1-d2
        move.w    d1,d5
        lsl.w     #2,d5
        suba.w    d5,a0
        move.w    d1,d5
        addq.l    #2,d7
        movea.l   d7,a1
p_loop1:
        dbf       d2,p_loop
        addq.l    #6,a7
        rts

op_tab:
        dc.w      s_fg0bg0-op_tab
        dc.w      s_fg0bg1-op_tab
        dc.w      s_fg1bg0-op_tab
        dc.w      s_fg1bg1-op_tab
        dc.w      x_fg0bg0-op_tab
        dc.w      x_fg0bg1-op_tab
        dc.w      x_fg1bg0-op_tab
        dc.w      x_fg1bg1-op_tab

r_lw_loop:
        move.w    (a1),d2
        swap      d2
        move.w    0(a1,d3.w),d2
        move.l    d2,(a2)+
        jmp       (a3)

store_lw:
        move.w    d2,0(a1,d3.w)
        swap      d2
        move.w    d2,(a1)
        adda.w    d4,a1
r_lw_entry:
        dbf       d5,r_lw_loop
        rts

fetch_rt:
        move.w    (a1),d2
        move.w    d2,(a2)+
        jmp       (a3)

store_rt:
        move.w    d2,(a1)
        adda.w    d4,a1
r_rt_entry:
        dbf       d5,fetch_rt
        rts

fetch_lf:
        move.w    (a1),d2
        move.w    d2,(a2)+
        swap      d2
        jmp       (a3)
store_lf:
        swap      d2
        move.w    d2,(a1)
        adda.w    d4,a1
r_lf_entry:
        dbf       d5,fetch_lf
        rts

r_rt_loop:
        moveq.l   #0,d0
        move.w    (a0)+,d0
        rol.l     d6,d0
        moveq.l   #0,d1
        move.w    (a0)+,d1
        rol.l     d6,d1
        jmp       (a4)

r_lf_loop:
        moveq.l   #0,d0
        move.w    (a0)+,d0
        swap      d0
        ror.l     d6,d0
        moveq.l   #0,d1
        move.w    (a0)+,d1
        swap      d1
        ror.l     d6,d1
        jmp       (a4)

s_fg0bg0:
        or.l      d1,d0
        not.l     d0
        and.l     d0,d2
        jmp       (a5)

s_fg0bg1:
        or.l      d0,d2
        not.l     d1
        and.l     d1,d2
        jmp       (a5)

s_fg1bg0:
        not.l     d0
        and.l     d0,d2
        or.l      d1,d2
        jmp       (a5)

s_fg1bg1:
        or.l      d0,d2
        or.l      d1,d2
        jmp       (a5)

x_fg0bg0:
        eor.l     d1,d2
        not.l     d0
        and.l     d0,d2
        jmp       (a5)

x_fg0bg1:
        or.l      d0,d2
        eor.l     d1,d2
        jmp       (a5)

x_fg1bg0:
        not.l     d0
        and.l     d0,d2
        eor.l     d1,d2
        jmp       (a5)

x_fg1bg1:
        eor.l     d0,d2
        or.l      d1,d2
        jmp       (a5)


cur_replace:
		bclr.b	#F_SAVRDY,SV_STAT(a2)   /* valid data in buffer? */
		beq	hang_it_up		/* 0:nothing saved */

		move.w	SV_LEN(a2),d4		/* d4 <- lines per plane */
		move.w	d4,d2
		subq.w	#1,d2			/* d2 <- adjust counter for dbra */
		move.w	v_lin_wr(a5),d3	/* d3 <- dy wrap value */

		move.l	SV_ADDR(a2),a0		/* a0 -> destination */
		lea	SV_BUF(a2),a1		/* a1 -> save buffer */

		move.w	v_planes(a5),d5	/* d5 <- rez discriminator */
		subq.w	#2,d5
		bhi	pln_4
		beq	pln_2

pln_1:		btst.b	#F_SAVWID,SV_STAT(a2)	/* word or longword ? */
		bne	pl1_lw_loop


/*********************************************************
 *		1 Plane case				*
 *********************************************************/
/*
 * 1 plane: word wide
 */
pl1_wd_loop:	move.w	(a1)+,(a0)
		add.w	d3,a0
		dbra	d2,pl1_wd_loop

		rts
/*
 * 1 plane: long word
 */
pl1_lw_loop:	move.l	(a1)+,(a0)
		add.w	d3,a0
		dbra	d2,pl1_lw_loop

		rts


/*********************************************************
 *		2 Plane case				*
 *********************************************************/
pln_2:		move.l	a0,a5			/* a5 <- destination */
		add.w	d4,d4			/* d4 <- word offset */

		btst.b	#F_SAVWID,SV_STAT(a2)	/* word or longword ? */
		bne	pl2_lw_enter

/*
 * 2 plane: word wide
 */
		move.l	a1,a2			/* a2 -> second plane (word) */
		add.w	d4,a2

pl2_wd_loop:	move.w	(a1)+,(a0)+		/* store plane 1 */
		move.w	(a2)+,(a0)		/* store plane 2 */
		add.w	d3,a5
		move.l	a5,a0			/* a0 -> next screen line */
		dbra	d2,pl2_wd_loop

		rts


/*
 * 2 plane: long word
 */
pl2_lw_enter:
		move.l	a1,a2
		add.w	d4,a2
		add.w	d4,a2			/* a2 -> second plane (longword) */

pl2_lw_loop:	move.w	(a1)+,(a0)+		/* 1st plane, hi word */
		move.w	(a2)+,(a0)+		/* 2nd plane, hi word */
		move.w	(a1)+,(a0)+		/* 1st plane, lo word */
		move.w	(a2)+,(a0)		/* 2nd plane, lo word */
		add.w	d3,a5
		move.l	a5,a0			/* a0 -> next line */
		dbra	d2,pl2_lw_loop

		rts


/*********************************************************
 *		4 Plane case				*
 *********************************************************/
pln_4:	move.l	a0,a5			/* a5 -> current line in plane 1 */
		add.w	d4,d4			/* d4 <- offset to next plane */
		btst.b	#F_SAVWID,SV_STAT(a2)	/* word or longword ? */
		bne	pl4_lw_enter


/*
 * 4 plane: word wide
 */
		move.l	a1,a2
		add.w	d4,a2			/* a2 -> 2nd plane */
		move.l	a2,a3
		add.w	d4,a3			/* a3 -> 3rd plane */
		move.l	a3,a4
		add.w	d4,a4			/* a4 -> 4th plane */

pl4_wd_loop:	move.w	(a1)+,(a0)+		/* store 1st plane */
		move.w	(a2)+,(a0)+		/* store 2nd plane */
		move.w	(a3)+,(a0)+		/* store 3rd plane */
		move.w	(a4)+,(a0)		/* store 4th plane */
		add.w	d3,a5
		move.l	a5,a0			/* a0 -> next line */
		dbra	d2,pl4_wd_loop

		rts

/*
 * 4 plane: long word
 */
pl4_lw_enter:	add.w	d4,d4			/* d4 <- plane offset */
		move.l	a1,a2			/* set up pointers to each plane */
		add.w	d4,a2
		move.l	a2,a3
		add.w	d4,a3
		move.l	a3,a4
		add.w	d4,a4

pl4_lw_loop:
		move.w 	(a1)+,(a0)+		/* 1st plane, hi word */
     	move.w	(a2)+,(a0)+		/* 2nd plane, hi word */
     	move.w	(a3)+,(a0)+		/* 3rd plane, hi word */
     	move.w	(a4)+,(a0)+		/* 4th plane, hi word */
       	move.w 	(a1)+,(a0)+		/* 1st plane, lo word */
     	move.w	(a2)+,(a0)+		/* 2nd plane, lo word */
     	move.w	(a3)+,(a0)+		/* 3rd plane, lo word */
     	move.w	(a4)+,(a0)		/* 4th plane, lo word */
		add.w	d3,a5
		move.l	a5,a0			/* a0 -> next line */
	    dbra   	d2,pl4_lw_loop

hang_it_up:
		rts



concat:
	move.w	d2,-(a7)
	move.w	d3,-(a7)
	
	muls	v_lin_wr(a5),d1	; d1 <- offset to (0,Y)

	move.w	v_planes(a5),d3
	move.b	shf_tab-1(pc,d3.w),d3	; d3 <- shift factor for plane adjust

	move.w	d0,d2			; d2[15:00] <- signed X
	ext.l	d2			; d2[31:00] <- signed X
	and.w	#$FFF0,d2		; clamp to word boundry
	asr.w	d3,d2			; d2 <- X displacement (in bytes)
	add.l	d2,d1			; d1 <- offset into screen

	and.w	#$000F,d0		; d0 <- X mod 16

	move.w	(a7)+,d3
	move.w	(a7)+,d2
	rts

shf_tab:   *    1 2   4       8		; number of planes

	dc.b	3,2,0,1,0,0,0,0		; right shift factor



                ;Interrupt-Routinen


new_vbl_color:move.b  #190,tbdr         ;Timer B
        move.b  #8,tbcr             ;Start
        rts

new_vbl_mono:
		move.l a0,-(a7)
		lea    timer_b_mono(pc),a0
		move.l  a0,hblintr
		move.b  #198,tbdr         ;Timer B
        move.b  #8,tbcr             ;Start
        move.l  (a7)+,a0
        rts


; Timer-B routine fuer color
timer_b_color:move.l  d0,-(sp)
        move    #$2700,sr           ;alle Ints gesperrt
w200:   cmpi.b  #180,tbdr           ;auf 200
        bne.s   w200                ;Pixelzeile warten
        move.b  #0,sync_mod         ;Sync-Bit
        move.w  #2,d0               ;kippeln
w:      nop
        dbra    d0,w                ;etwas warten
        move.b  #2,sync_mod
        move    #$2300,sr
        move.b  #0,tbcr             ;Zaehler stop
        move.l  (sp)+,d0
        bclr    #0,isra             ;Interrupt-Service fertig
        rte

; Timer-B routine fuer monochrome
timer_b_mono:
                clr.b   tbcr.w
                movem.l D0/A0,-(SP)
                move    #$2700,SR

                move.b  vcountlow.w,D0
tb_sync:        cmp.b   vcountlow.w,D0
                beq.s   tb_sync
                not.w   D0
                lsr.w   D0,D0

                lea     tbdr.w,A0
                move.b  #200-3,(A0)
                lea     border(pc),a0
                move.l  a0,hblintr.w
                move    #$2300,SR
                move.b  #8,tbcr.w
                movem.l (SP)+,D0/A0
        bclr    #0,isra             ;Interrupt-Service fertig
                rte

border:			move    #$2700,SR
                movem.l D0/A0,-(SP)
                lea     vcountlow.w,A0

                move.w  #$0F+1,D0       ;8  ; Einige Zeit warten
dss:            nop     ; 16*4
                dbra    D0,dss          ; 12*16

                addq.w  #2,D0
                lsl.w   D0,D0

                move.b  (A0),D0         ; Synchronisieren
sync:           cmp.b   (A0),D0
                beq.s   sync
                not.w   D0
                lsl.l   D0,D0

delay1:         bra.w   nops1-(65*2)
                REPT 100
                nop
                ENDM
nops1:

                move.b  #0,shiftmode.w
delay2:         bra.w   nops2-(11*2)
                REPT 40
                nop
                ENDM
nops2:
                move.b  #2,shiftmode.w  ;70hz

                movem.l (SP)+,D0/A0
        bclr    #0,isra             ;Interrupt-Service fertig
                rte

        even
        
old_vektor: ds.l 1
return:     ds.l 1
vdipb:      ds.l 1
linea_param:ds.l 1
old_stack:  ds.l 1
screensize: dc.l 32000+(110*80)

		.even

;bis hier ist das Programm resident !!


init:   movea.l 4(sp),a6            ;Adresse der Basepage
        move.w  #$0100,d7           ;Laenge der Basepage
        add.l   12(a6),d7           ;Laenge des Text-Segments
        add.l   20(a6),d7           ;Laenge des Daten-Segments
        add.l   28(a6),d7           ;Laenge des Speicher-/Segments
        move.w  #4,-(sp)            ;Bildschirmaufloesung holen
        trap    #14                 ;Getrez
        addq.l  #2,sp
        cmp.w   #2,d0
        bhi     error1              ;monochrom kann ich nicht !

        dc.w    $a000               ;Line-A Init
        lea     linea_param(pc),a1
        move.l  a0,a5
        move.l  a0,(a1)             ;merken

        clr.l   -(sp)               ;Supermodus
        move.w  #32,-(sp)
        trap    #1
        addq.l  #6,sp
        lea     old_stack(pc),a1
        move.l  d0,(a1)             ;alten Stack merken

;        sub.l   #init_end-init,d7   ;Initialisierungsteil wegwerfen
        move.l  a6,d6               ;Adresse Base-Page
        add.l   d7,d6
        add.l   #255,d6             ;wegen Videoprozessor
        clr.b   d6

;neue physikalische und logische
;Bildanfangsadresse setzen

        move.w  #-1,-(sp)
        move.l  d6,-(sp)            ;neue Bildanfangsadresse
        move.l  d6,-(sp)            ;logische Bildanfangsadresse
        move.w  #5,-(sp)            ;Setscreen
        trap    #14
        lea     12(sp),sp

;VBL-Interrupt in Queue eintragen

        movea.l vblqueue,a0
        addq.l  #4,a0               ;1.Eintrag freilassen (fuer GEM)
        move.w  nvbls,d0
        subq.w  #2,d0
such:   move.l  (a0)+,d1
        beq.s   eintrag             ;leeren Eintrag gefunden
        dbra    d0,such             ;weitersuchen
        bra     error2

eintrag:
        lea     new_vbl_color(pc),a1
        lea     timer_b_color(pc),a2
        move.b  #190,d0
        move.l  linea_param(pc),a5
        cmp.w   #1,v_planes(a5)
        bne     eintrag_color
        lea     new_vbl_mono(pc),a1
        lea     timer_b_mono(pc),a2
        move.b  #198,d0
eintrag_color:
        move.l  a1,-(a0)

;Timer-B-Interrupt initialisieren

        move.l  a2,hblintr          ;Beginn der Interruptroutine
        move.b  #0,tbcr             ;Timer gestoppt

;MFP Timer B initialisieren

        andi.b  #$f7,aer            ;H-L Flanke wirksam
        move.b  d0,tbdr             ;Int. bei zeile
        ori.b   #1,imra             ;Interruptmaske freigeben
        ori.b   #1,iera             ;Interrupt Timer B einschalten
        move.w  #37,-(sp)           ;Wait Vbl
        trap    #14
        addq.l  #2,sp
        move.b  #8,tbcr             ;Ereigniszaehlung

;Trap #2-Vektor verbiegen

        pea     trap_2(pc)
        move.w  #34,-(sp)           ;Trap #2
        move.w  #5,-(sp)            ;neuen Vektor setzen
        trap    #13                 ;Setexc
        addq.l  #8,sp
        lea     old_vektor(pc),a1
        move.l  d0,(a1)             ;alten Vektor merken

        move.l  old_stack(pc),-(sp) ;User-Modus
        move.w  #32,-(sp)
        trap    #1
        addq.l  #6,sp

;Programm resident hinterlassen

        add.l   screensize(pc),d6  ;Groesse Bildspeicher
        sub.l   a6,d6               ;benoetigter Speicherplatz
        clr.w   -(sp)               ;Status ok
        move.l  d6,-(sp)            ;Laenge
        move.w  #$31,-(sp)
        trap    #1                  ;Ptermres

;Error-Meldung

error1: pea     err_txt1(pc)
        bra.s   error
error2: pea     err_txt2(pc)
error:  move.w  #9,-(sp)            ;Cconws
        trap    #1
        addq.l  #6,sp

        move.w  #-1,d0
warte:  dbra    d0,warte

        clr.w   -(sp)
        trap    #1

        even
err_txt1:dc.b   "Nur niedrige, mittlere oder hohe Aufl',$94,'sung !",0
err_txt2:dc.b   "Alle VBL-Slots belegt !",0
err_txt3:dc.b   "Unbekannte TOS-Version !",0
        even
init_end:
        end
